//////////////////////////////////////////////////////////////////////////
// BonSDK .NET binding interface library
// Copyright (c) http://2sen.dip.jp/dtv/
//
// This is part of BonSDK.
// BonSDK comes with ABSOLUTELY NO WARRANTY;
// for details see 'GNU GENERAL PUBLIC LICENSE 2.0'.

using System;
using System.Threading;
using System.Runtime.InteropServices;
using System.ComponentModel;

namespace Bon
{
	/// <summary>
	/// Xg[f[^~ςL[C^[tFCXłB
	/// </summary>
	[ComVisible(true)]
	[Guid("99DD6FA8-12A5-464c-8DB0-511FDA6C06D7")]
	[InterfaceType(ComInterfaceType.InterfaceIsDual)]
	[TypeConverter(typeof(ExpandableObjectConverter))]
	public interface IDataQueue : IDisposable
	{
		/// <summary>
		/// L[ێĂXg[f[^j܂B
		/// </summary>
		void Purge();

		/// <summary>
		/// L[ɃXg[f[^~ςꂽǂҋ@oWaitHandlẽCX^X擾܂B
		/// </summary>
		/// <remarks>WaitHandlegpāAL[ɃXg[f[^~ς̂ҋ@o܂B
		/// WaitHandle^Ȃ̂ŁÃVOiƓɑҋ@邱Ƃo܂B</remarks>
		[ComVisible(false)]
		[Browsable(false)]
		WaitHandle CanDequeue
		{
			get;
		}

		/// <summary>
		/// L[ɃXg[f[^~ςꂽǂҋ@oJ[lIuWFNg̃nh擾܂B
		/// </summary>
		/// <remarks>̃nhgpāAL[ɃXg[f[^~ς̂ҋ@o܂B
		/// J[lIuWFNgnhȂ̂ŁÃVOiƓɑҋ@邱Ƃo܂B
		/// ̃vpeB͑݉^p̂̂łBʏCanDequeueœWaitHandlegpĉB</remarks>
		[Browsable(false)]
		[EditorBrowsable(EditorBrowsableState.Advanced)]
		IntPtr CanDequeueHandle
		{
			get;
		}
		
		/// <summary>
		/// L[ɒ~ςĂXg[f[^擾܂B
		/// </summary>
		int Count
		{
			get;
		}

		/// <summary>
		/// L[ɒ~ς邱ƂoXg[f[^̍voCg擾܂B
		/// </summary>
		long MaxSize
		{
			get;
		}

		/// <summary>
		/// L[ɒ~ςĂXg[f[^̍voCg擾܂B
		/// </summary>
		long TotalSize
		{
			get;
		}

		/// <summary>
		/// ̃L[bNĂ邩ǂ擾܂B
		/// </summary>
		/// <remarks>L[ɑ΂郍bNrŕύX邱Ƃ͏o܂B
		/// bNĂƁAT[rXIDvOID̕ύXo܂B</remarks>
		bool IsLocked
		{
			get;
		}

		/// <summary>
		/// ̃L[~ςΏۂ̃T[rXID擾Eݒ肵܂B
		/// </summary>
		/// <remarks>T[rXIDƂ-1w肷ƁASẴXg[f[^L[ɒ~ς܂B
		/// 0w肷ƁAKȎM\ȃXg[f[^IĒ~ς܂B
		/// AAǂ̃Xg[f[^Iꂽ͕܂B</remarks>
		int ServiceID
		{
			get;
			set;
		}

		/// <summary>
		/// ̃L[~ςΏۂ̃vOID擾Eݒ肵܂B
		/// </summary>
		/// <remarks>vOIDƂ-1w肷ƁAvǑos܂B
		/// vOIDw肵ꍇ͈vvOoÃf[^~ς܂B</remarks>
		int ProgramID
		{
			get;
			set;
		}

		/// <summary>
		/// Xg[f[^L[擾܂B
		/// </summary>
		/// <returns>Xg[f[^̃CX^X</returns>
		/// <remarks>L[ɃXg[f[^~ςĂȂꍇ́A\bhőҋ@܂
		/// i̕@͐܂BCanDequeuevpeBQƂĉjB</remarks>
		ITsData Dequeue();

		/// <summary>
		/// Xg[f[^L[擾܂B
		/// </summary>
		/// <returns>Xg[f[^̃CX^X</returns>
		/// <remarks>L[ɃXg[f[^~ςĂȂꍇ́A\bhőҋ@܂
		/// i̕@͐܂BCanDequeueHandlevpeBQƂĉjB
		/// ̃\bh͑݉^p̂̂łBʏDequeue\bhgpĉB</remarks>
		[EditorBrowsable(EditorBrowsableState.Advanced)]
		IRawTsData RawDequeue();
	}
}
