//////////////////////////////////////////////////////////////////////////
// BonSDK .NET binding interface library
// Copyright (c) http://2sen.dip.jp/dtv/
//
// This is part of BonSDK.
// BonSDK comes with ABSOLUTELY NO WARRANTY;
// for details see 'GNU GENERAL PUBLIC LICENSE 2.0'.

using System;
using System.Runtime.InteropServices;

namespace Bon.IEPG
{
	/// <summary>
	/// u[hLXgʂ񋓒lłB
	/// </summary>
	[ComVisible(true)]
	[Guid("0C9AD999-39CA-4276-B2D9-AB32F5ED5EEB")]
	public enum BroadcastType
	{
		/// <summary>
		/// s
		/// </summary>
		Unknown,

		/// <summary>
		/// nfW^erW
		/// </summary>
		DFS,

		/// <summary>
		/// BSfW^erW
		/// </summary>
		BSDT,

		/// <summary>
		/// CSfW^erW
		/// </summary>
		CSDT
	};

	/// <summary>
	/// iEPGf[^̃ACeC^[tFCXłB
	/// </summary>
	[ComVisible(true)]
	[Guid("552398C2-03E8-4ad2-AE30-FFDBAFC8D4B2")]
	[InterfaceType(ComInterfaceType.InterfaceIsDual)]
	public interface IIEPGItem
	{
		BroadcastType BroadcastType
		{
			get;
		}

		int ServiceID
		{
			get;
		}

		string TransportStreamName
		{
			get;
		}

		DateTime StartTime
		{
			get;
		}

		DateTime EndTime
		{
			get;
		}

		string Title
		{
			get;
		}

		int ProgramID
		{
			get;
		}

		string Body
		{
			get;
		}

		string this[string name]
		{
			get;
		}
	}
}
