//////////////////////////////////////////////////////////////////////////
// BonSDK .NET binding interface library
// Copyright (c) http://2sen.dip.jp/dtv/
//
// This is part of BonSDK.
// BonSDK comes with ABSOLUTELY NO WARRANTY;
// for details see 'GNU GENERAL PUBLIC LICENSE 2.0'.

using System;
using System.Net;
using System.Runtime.InteropServices;
using System.Runtime.InteropServices.ComTypes;

namespace Bon.Remoting
{
	/// <summary>
	/// Xg[T[rXzMXg[ɐڑC^[tFCXłB
	/// </summary>
	/// <remarks>̃C^[tFCXCOM݉^pŎgp܂B</remarks>
	[ComVisible(true)]
	[Guid("8A0670BB-7E93-4eaf-A724-FAE484F7C103")]
	[InterfaceType(ComInterfaceType.InterfaceIsDual)]
	public interface IStreamClient : IStream
	{
		/// <summary>
		/// Xg[T[rXɐڑ܂B
		/// </summary>
		/// <param name="url">Xg[T[rXURL</param>
		/// <param name="tuningSpace">`[jOXy[Xԍ</param>
		/// <param name="channel">`l</param>
		/// <param name="serviceID">T[rXID</param>
		/// <param name="programID">vOID</param>
		/// <param name="connectTimeout">ڑ̃^CAEgԁi~bj</param>
		/// <param name="streamTimeout">Xg[M̃^CAEgԁi~bj</param>
		/// <param name="locked">`[i[bNꍇtrue</param>
		/// <param name="userAgent">ڑɎgp郆[U[G[WFg</param>
		/// <remarks>`[jOXy[X̓`l-1̏ꍇ͖wƂȂAݑIǂĂ`lgp܂B
		/// T[rXIDƂ-1w肷ƁASẴXg[f[^M܂B
		/// 0w肷ƁAKȎM\ȃXg[f[^IĎM܂B
		/// AAǂ̃Xg[f[^Iꂽ͕܂B
		/// vOIDƂ-1w肷ƁAvǑos܂B
		/// vOIDw肵ꍇ͈vvOoÃf[^M܂B</remarks>
		void Connect(IUrl url, int tuningSpace, int channel, int serviceID, int programID,
			int connectTimeout, int streamTimeout, bool locked, string userAgent);

		/// <summary>
		/// Xg[N[Y܂B
		/// </summary>
		void Close();

		/// <summary>
		/// [JGh|Cg擾܂B
		/// </summary>
		IStreamEndPoint LocalEndPoint
		{
			get;
		}

		/// <summary>
		/// ݂̃Xg[oCg V[PXǂݎAǂݎoCg̕Xg[̈ʒui߂܂B
		/// </summary>
		/// <param name="buffer">oCgzB̃\bh߂ƂAw肵oCgz offset  (offset + count -1) ܂ł̒lÃ݂\[XǂݎꂽoCgɒu܂B</param>
		/// <param name="offset">݂̃Xg[ǂݎf[^̊i[Jnʒu buffer ̃oCg ItZbgBCfbNXԍ 0 n܂܂B</param>
		/// <param name="count">݂̃Xg[ǂݎőoCgB</param>
		/// <returns>obt@ɓǂݎꂽvoCgBṽoCgǂݎ邱ƂłȂꍇA̒l͗voCg菬Ȃ܂B</returns>
		int Read(byte[] buffer, int offset, int count);

		/// <summary>
		/// 񓯊̓ǂݍݓJn܂B
		/// </summary>
		/// <param name="buffer">f[^ǂݍރobt@</param>
		/// <param name="offset">Xg[ǂݍ񂾃f[^̏݊Jnʒu buffer ̃oCg ItZbg</param>
		/// <param name="count">ǂݎőoCg</param>
		/// <param name="callback">ǂݎ芮ɌĂяoIvV̔񓯊R[obN</param>
		/// <param name="state">̓̔񓯊ǂݎv𑼂̗vƋʂ邽߂Ɏgp郆[U[w̃IuWFNg</param>
		/// <returns>񓯊̓ǂݍ݂\ System.IAsyncResultB܂ۗԂ̏ꍇ܂B</returns>
		IAsyncResult BeginRead(byte[] buffer, int offset, int count, AsyncCallback callback, object state);

		/// <summary>
		/// ۗ̔񓯊ǂݎ肪܂őҋ@܂B
		/// </summary>
		/// <param name="asyncResult">IۗԂ̔񓯊NGXgւ̎Q</param>
		/// <returns>Xg[ǂݎoCg (0 `voCg̊Ԃ̐l)B[ (0) Ԃ̂́AXg[̖œǂݎ낤ƂƂłBȊȌꍇ́AȂƂ
		//     1 oCgǂݍ݉\ɂȂ܂ŃubN܂B</returns>
		int EndRead(IAsyncResult asyncResult);

		/// <summary>
		/// Xg[݂̌̃V[N |C^ʂ̃Xg[݂̌̃V[N |C^Ɏw肵oCgRs[܂B
		/// </summary>
		/// <param name="pstm">Rs[Xg[ւ̎QƁB</param>
		/// <param name="cb">Rs[Xg[Rs[oCgB</param>
		/// <param name="pcbRead">ɕԂꂽꍇ́ARs[ǂݎꂽۂ̃oCgi[܂B</param>
		/// <param name="pcbWritten">ɕԂꂽꍇ́ARs[ɏ܂ꂽۂ̃oCgi[܂B</param>
		new void CopyTo(IStream pstm, long cb, IntPtr pcbRead, IntPtr pcbWritten);

		/// <summary>
		/// ݂̃V[N |C^Jn_ƂāAXg[ IuWFNg烁Ɏw肵oCgǂݎ܂B
		/// </summary>
		/// <param name="pv">̃\bhԂƂɁAXg[ǂݎꂽf[^i[܂B̃p[^͏ɓn܂B</param>
		/// <param name="cb">Xg[ IuWFNgǂݎoCgB</param>
		/// <param name="pcbRead">Xg[ IuWFNgǂݎꂽۂ̃oCg󂯎 ULONG ϐւ̃|C^B</param>
		new void Read(byte[] pv, int cb, IntPtr pcbRead);
	}
}
