//////////////////////////////////////////////////////////////////////////
// BonSDK .NET binding interface library
// Copyright (c) http://2sen.dip.jp/dtv/
//
// This is part of BonSDK.
// BonSDK comes with ABSOLUTELY NO WARRANTY;
// for details see 'GNU GENERAL PUBLIC LICENSE 2.0'.

using System;
using System.ComponentModel;
using System.Net;
using System.Runtime.InteropServices;

namespace Bon.Remoting
{
	/// <summary>
	/// IPAhXC^[tFCXłB
	/// </summary>
	[ComVisible(true)]
	[Guid("1AFFDB7A-0242-41a0-9289-82199433D204")]
	[InterfaceType(ComInterfaceType.InterfaceIsDual)]
	[TypeConverter(typeof(StreamAddressConverter))]
	public interface IStreamAddress
	{
		/// <summary>
		/// IPAhX̕\AhX擾܂B
		/// </summary>
		/// <param name="address">IPAhX̕\</param>
		[EditorBrowsable(EditorBrowsableState.Never)]
		IStreamAddress CreateFromString(string address);

		/// <summary>
		/// IPAhX̕\擾܂B
		/// </summary>
		/// <returns>IPAhX̕\</returns>
		string ToString();
	}

	/// <summary>
	/// IP AhXƃ|[gԍŃlbg[N Gh|Cg\C^[tFCXłB
	/// </summary>
	[ComVisible(true)]
	[Guid("D0F249F7-814B-4e21-B162-913F77EA96A5")]
	[InterfaceType(ComInterfaceType.InterfaceIsDual)]
	[TypeConverter(typeof(ExpandableObjectConverter))]
	public interface IStreamEndPoint
	{
		/// <summary>
		/// Gh|Cg IP AhX擾܂͐ݒ肵܂B
		/// </summary>
		IStreamAddress Address { get; set; }
		
		/// <summary>
		/// Gh|Cg̃|[gԍ擾܂͐ݒ肵܂B
		/// </summary>
		int Port { get; set; }

		/// <summary>
		/// w肳ꂽGh|Cgǂ擾܂B
		/// </summary>
		/// <param name="endPoint">Gh|Cg</param>
		/// <returns>Ȃtrue</returns>
		bool Equals(IStreamEndPoint endPoint);

		/// <summary>
		/// Gh|Cg̕`擾܂B
		/// </summary>
		/// <returns></returns>
		string ToString();
	}
}
