//////////////////////////////////////////////////////////////////////////
// BonSDK .NET binding interface library
// Copyright (c) http://2sen.dip.jp/dtv/
//
// This is part of BonSDK.
// BonSDK comes with ABSOLUTELY NO WARRANTY;
// for details see 'GNU GENERAL PUBLIC LICENSE 2.0'.

using System;
using System.Collections;
using System.Collections.Generic;
using System.ComponentModel;
using System.Runtime.InteropServices;

namespace Bon.Remoting
{
	/// <summary>
	/// T[rX𒊏ۉNXłB
	/// </summary>
	/// <remarks>̃NX̓VA\œǂݎpłB</remarks>
	[Serializable]
	[TypeConverter(typeof(ExpandableObjectConverter))]
	public sealed class RemoteServiceInformation : IRemoteServiceInformation
	{
		private readonly string name_;
		private readonly int serviceID_;

		/// <summary>
		/// RXgN^łB
		/// </summary>
		/// <param name="service">T[rX</param>
		public RemoteServiceInformation(IServiceInformation service)
		{
			name_ = service.Name;
			serviceID_ = service.ServiceID;
		}

		/// <summary>
		/// T[rX擾܂B
		/// </summary>
		[Category("Service")]
		public string Name
		{
			get
			{
				return name_;
			}
		}

		/// <summary>
		/// T[rXID擾܂B
		/// </summary>
		[Category("Service")]
		public int ServiceID
		{
			get
			{
				return serviceID_;
			}
		}
	}
}
