//////////////////////////////////////////////////////////////////////////
// BonSDK .NET binding interop library
// Copyright (c) http://2sen.dip.jp/dtv/
//
// This is part of BonSDK.
// BonSDK comes with ABSOLUTELY NO WARRANTY;
// for details see 'GNU GENERAL PUBLIC LICENSE 2.0'.


#pragma once

namespace Bon
{
	ref class ServiceInformation;

	ref class ChannelInformation sealed
		: public IChannelInformation
	{
	private:
		initonly System::String^ name_;
		array<ServiceInformation^>^ services_;

		virtual IChannelInformation^ InterfaceClone() sealed = IChannelInformation::Clone;
		virtual System::Object^ ObjectClone() sealed = System::ICloneable::Clone;

		ChannelInformation(ChannelInformation^ rhs);

	internal:
		ChannelInformation(System::String^ name);
		void SetServices(array<ServiceInformation^>^ services);

	public:
		virtual int GetHashCode() override;

		property System::String^ Name
		{
			virtual System::String^ get();
		}

		virtual ChannelInformation^ Clone();

		virtual System::Collections::IEnumerator^ GetEnumerator();
	};
}
