//////////////////////////////////////////////////////////////////////////
// BonSDK .NET binding interop library
// Copyright (c) http://2sen.dip.jp/dtv/
//
// This is part of BonSDK.
// BonSDK comes with ABSOLUTELY NO WARRANTY;
// for details see 'GNU GENERAL PUBLIC LICENSE 2.0'.


#pragma once

namespace Bon
{
	ref class EpgData
		: public IEpgData
	{
	private:
		IEpgItem *pEpgItem_;

	internal:
		EpgData(const IEpgItem *pEpgItem);

	public:
		!EpgData();
		~EpgData();

		property EpgDataStates EpgDataStatus
		{
			virtual EpgDataStates get();
		}

		property int ProgramID
		{
			virtual int get();
		}

		property System::DateTime StartTime
		{
			virtual System::DateTime get();
		}

		property System::DateTime EndTime
		{
			virtual System::DateTime get();
		}

		property bool IsScrambled
		{
			virtual bool get();
		}

		property System::String^ EventTitle
		{
			virtual System::String^ get();
		}

		property System::String^ EventInfo
		{
			virtual System::String^ get();
		}

		property System::String^ EventDetail
		{
			virtual System::String^ get();
		}

		property int VideoResolution
		{
			virtual int get();
		}

		property bool IsVideoProgressive
		{
			virtual bool get();
		}

		property bool IsVideoAspectWide
		{
			virtual bool get();
		}

		property bool IsVideoPanAndScan
		{
			virtual bool get();
		}

		property AudioModes AudioMode
		{
			virtual AudioModes get();
		}

		property int Genre
		{
			virtual int get();
		}

		virtual int GetGenreLevel1(int index);
		virtual int GetGenreLevel2(int index);
	};
}
