//////////////////////////////////////////////////////////////////////////
// BonSDK .NET binding interop library
// Copyright (c) http://2sen.dip.jp/dtv/
//
// This is part of BonSDK.
// BonSDK comes with ABSOLUTELY NO WARRANTY;
// for details see 'GNU GENERAL PUBLIC LICENSE 2.0'.


#include "stdafx.h"

#include "ServiceInformation.h"

namespace Bon
{
	ServiceInformation::ServiceInformation(System::String^ name, int serviceID)
		: name_(name), serviceID_(serviceID)
	{
	}

	ServiceInformation::ServiceInformation(ServiceInformation^ rhs)
		: name_(rhs->name_), serviceID_(rhs->serviceID_)
	{
	}

	int ServiceInformation::GetHashCode()
	{
		return name_->GetHashCode() ^ serviceID_.GetHashCode();
	}

	System::String^ ServiceInformation::Name::get()
	{
		return name_;
	}

	int ServiceInformation::ServiceID::get()
	{
		return serviceID_;
	}

	ServiceInformation^ ServiceInformation::Clone()
	{
		return gcnew ServiceInformation(this);
	}

	IServiceInformation^ ServiceInformation::InterfaceClone()
	{
		return gcnew ServiceInformation(this);
	}

	System::Object^ ServiceInformation::ObjectClone()
	{
		return gcnew ServiceInformation(this);
	}
}
