//////////////////////////////////////////////////////////////////////////
// BonSDK .NET binding interop library
// Copyright (c) http://2sen.dip.jp/dtv/
//
// This is part of BonSDK.
// BonSDK comes with ABSOLUTELY NO WARRANTY;
// for details see 'GNU GENERAL PUBLIC LICENSE 2.0'.


#pragma once

namespace Bon
{
	ref class ServiceInformation;
	ref class ChannelInformation;

	ref class TuningSpaceInformation sealed
		: public ITuningSpaceInformation
	{
	private:
		initonly System::String^ name_;
		initonly array<ChannelInformation^>^ channels_;

		virtual ITuningSpaceInformation^ InterfaceClone() sealed = ITuningSpaceInformation::Clone;
		virtual System::Object^ ObjectClone() sealed = System::ICloneable::Clone;

		TuningSpaceInformation(TuningSpaceInformation^ rhs);

	internal:
		TuningSpaceInformation(System::String^ name, array<ChannelInformation^>^ channels);
		void SetServices(int channel, array<ServiceInformation^>^ services);

	public:
		virtual int GetHashCode() override;

		property System::String^ Name
		{
			virtual System::String^ get();
		}

		virtual TuningSpaceInformation^ Clone();

		virtual System::Collections::IEnumerator^ GetEnumerator();
	};
}
