//////////////////////////////////////////////////////////////////////////
// BonSDK Stream service connection library (BonDriver interface)
// Copyright (c) http://2sen.dip.jp/dtv/
//
// This is part of BonSDK.
// BonSDK comes with ABSOLUTELY NO WARRANTY;
// for details see 'GNU GENERAL PUBLIC LICENSE 2.0'.

// IBonDriver3.h: IBonDriver3 NX̃C^[tFCX
//
/////////////////////////////////////////////////////////////////////////////

#pragma once


#include "IBonDriver2.h"


/////////////////////////////////////////////////////////////////////////////
// BonhCoC^tF[X3
/////////////////////////////////////////////////////////////////////////////

class IBonDriver3 : public IBonDriver2
{
public:
// IBonDriver3
	virtual const DWORD GetTotalDeviceNum(void) = 0;
	virtual const DWORD GetActiveDeviceNum(void) = 0;
	virtual const BOOL SetLnbPower(const BOOL bEnable) = 0;
	
// IBonDriver
	virtual void Release(void) = 0;
};
