//////////////////////////////////////////////////////////////////////////
// BonSDK EARTHSOFT PT2 tuner library
// Copyright (c) http://2sen.dip.jp/dtv/
//
// This is part of BonSDK.
// BonSDK comes with ABSOLUTELY NO WARRANTY;
// for details see 'GNU GENERAL PUBLIC LICENSE 2.0'.

// DllMain.cpp: DLLGg[|Cg̒`
//
/////////////////////////////////////////////////////////////////////////////

#include "StdAfx.h"
#include "BonSDK.h"
#include "Pt2TerTuner.h"
#include "Pt2SatTuner.h"
#include "Pt2TriTuner.h"
#include "ModCatalog.h"


/////////////////////////////////////////////////////////////////////////////
// t@C[J֐vg^Cv
/////////////////////////////////////////////////////////////////////////////

static void RegisterClass(void);


/////////////////////////////////////////////////////////////////////////////
// DLLGg[
/////////////////////////////////////////////////////////////////////////////

BOOL APIENTRY DllMain(HMODULE hModule, DWORD  ul_reason_for_call, LPVOID lpReserved)
{
	switch(ul_reason_for_call){
		case DLL_PROCESS_ATTACH :

			// [NoL
			_CrtSetDbgFlag(_CRTDBG_ALLOC_MEM_DF | _CRTDBG_CHECK_ALWAYS_DF | _CRTDBG_LEAK_CHECK_DF); 

			// NXo^
			g_hModule = hModule;
			::RegisterClass();

			break;

		case DLL_PROCESS_DETACH :
			
			break;
		}

	return TRUE;
}


static void RegisterClass(void)
{
	// NXo^
	::BON_REGISTER_CLASS<PT2Driver>();
	::BON_REGISTER_CLASS<CPt2TerTuner>();
	::BON_REGISTER_CLASS<CPt2SatTuner>();
	::BON_REGISTER_CLASS<CPt2TriTuner>();

	::BON_REGISTER_CLASS<CPt2BaseTunerProperty>();
}
