//////////////////////////////////////////////////////////////////////////
// BonSDK EARTHSOFT PT2 tuner library
// Copyright (c) http://2sen.dip.jp/dtv/
//
// This is part of BonSDK.
// BonSDK comes with ABSOLUTELY NO WARRANTY;
// for details see 'GNU GENERAL PUBLIC LICENSE 2.0'.

// Pt2TerTuner.h: PT2ng`[iNX
//
/////////////////////////////////////////////////////////////////////////////

#pragma once


#include "Pt2BaseTuner.h"



/////////////////////////////////////////////////////////////////////////////
// PT2ng`[iNX
/////////////////////////////////////////////////////////////////////////////

class CPt2TerTuner :	public CPt2BaseTuner
{
public:
// CBonObject
	DECLARE_IBONOBJECT(CPt2TerTuner)

// CPt2BaseTuner
	virtual const CBonString EnumTuningSpace(const DWORD dwSpace) const;
	virtual const CBonString EnumChannelName(const DWORD dwSpace, const DWORD dwChannel) const;
	virtual const bool SetChannel(const DWORD dwSpace, const DWORD dwChannel);

// IConfigTarget
	virtual const bool SetProperty(const IConfigProperty *pProperty);

// CPt2TerTuner
	CPt2TerTuner(IBonObject *pOwner);
	virtual ~CPt2TerTuner(void);

protected:
};
