//////////////////////////////////////////////////////////////////////////
// BonSDK .NET binding interface library
// Copyright (c) http://2sen.dip.jp/dtv/
//
// This is part of BonSDK.
// BonSDK comes with ABSOLUTELY NO WARRANTY;
// for details see 'GNU GENERAL PUBLIC LICENSE 2.0'.

using System;
using System.Runtime.InteropServices;
using System.ComponentModel;

namespace Bon
{
	/// <summary>
	/// `[i[𒊏ۉC^[tFCXłB
	/// </summary>
	/// <remarks>`[i[̐ɕKvȃ\bhEvpeB`Ă܂B</remarks>
	[ComVisible(true)]
	[Guid("428586CC-0B11-4828-BB59-988827953A7E")]
	[InterfaceType(ComInterfaceType.InterfaceIsDual)]
	[TypeConverter(typeof(ExpandableObjectConverter))]
	public interface ITuner : IDisposable
	{
		/// <summary>
		/// `[i[擾܂B
		/// </summary>
		/// <remarks>`[i[BonSDK̃`[i[NXłB
		/// Ⴆ΍FriioȂA"CBonBlackTuner"Ԃ܂B</remarks>
		string TunerName
		{
			get;
		}

		/// <summary>
		/// foCX擾܂B
		/// </summary>
		/// <remarks>foCX̓`[i[NX瓾ꂽ[U[ǉ\ȕłB</remarks>
		string DeviceName
		{
			get;
		}

		/// <summary>
		/// ̃`[i[M\ȃ`[jOXy[Xƃ`l̏擾܂B
		/// </summary>
		ITuningSpaceInformation[] TuningSpaces
		{
			get;
		}

		/// <summary>
		/// foCXID擾܂B
		/// </summary>
		/// <remarks>ނ̃`[i[݂ꍇɁAقȂlԂ܂B</remarks>
		int DeviceID
		{
			get;
		}

		/// <summary>
		/// `[i[̃bNԂ擾܂B
		/// </summary>
		bool IsLocked
		{
			get;
		}

		/// <summary>
		/// `[i[AbN܂B
		/// </summary>
		/// <param name="cookie">bNNbL[</param>
		void Unlock(Guid cookie);

		/// <summary>
		/// `[i[ғǂ擾܂B
		/// </summary>
		bool IsRunning
		{
			get;
		}

		/// <summary>
		/// J[hID擾܂B
		/// </summary>
		byte[] CardID
		{
			get;
		}

		/// <summary>
		/// J[hɑ΂EMMKp邩ǂ擾Eݒ肵܂B
		/// </summary>
		bool EnableEmmProcess
		{
			get;
			set;
		}

		/// <summary>
		/// `[i[ɐڑĂAeipLNBdL邩ǂ擾Eݒ肵܂B
		/// </summary>
		bool EnableLnbPower
		{
			get;
			set;
		}

		/// <summary>
		/// `[i[ɐڑĂAeǐ݂̎Mx擾܂B
		/// </summary>
		float SignalLevel
		{
			get;
		}

		/// <summary>
		/// ݑIĂ`[jOXy[X擾܂B
		/// </summary>
		/// <remarks>`[jOXy[Xƃ`l̗̏𓾂ꍇA
		/// ̃vpeBgpƐʂȂ\܂B
		/// 𓾂邽߂ɂ́ÃvpeBł͂ȂGetChannel\bhgp܂B</remarks>
		int TuningSpace
		{
			get;
		}

		/// <summary>
		/// ݑIĂ`l擾܂B
		/// </summary>
		/// <remarks>`[jOXy[Xƃ`l̗̏𓾂ꍇA
		/// ̃vpeBgpƐʂȂ\܂B
		/// 𓾂邽߂ɂ́ÃvpeBł͂ȂGetChannel\bhgp܂B</remarks>
		int Channel
		{
			get;
		}

		/// <summary>
		/// ݑIĂ`[jOXy[Xƃ`l擾܂B
		/// </summary>
		ISelectedChannel GetChannel();

		/// <summary>
		/// ̃`[i[̃`[jOXy[Xƃ`lݒ肵܂B
		/// </summary>
		/// <param name="tuningSpace">`[jOXy[X</param>
		/// <param name="channel">`l</param>
		/// <param name="serviceID">T[rXID</param>
		/// <remarks>CreateQueueŐSẴL[́A
		/// IɎw肳ꂽT[rXIDƃvOID=-1ɕύX܂
		/// iAA`[jOXy[Xƃ`lɕύXȂꍇ͖܂jB
		/// T[rXIDƂ-1w肷ƁASẴXg[f[^M܂B
		/// 0w肷ƁAKȎM\ȃXg[f[^IđM܂B
		/// AAǂ̃Xg[f[^Iꂽ͕܂B</remarks>
		void SetChannel(int tuningSpace, int channel, int serviceID);

		/// <summary>
		/// ̃`[i[̃`[jOXy[Xƃ`lݒ肵܂B
		/// </summary>
		/// <param name="tuningSpace">`[jOXy[X</param>
		/// <param name="channel">`l</param>
		/// <param name="serviceID">T[rXID</param>
		/// <returns>bNNbL[</returns>
		/// <remarks>`[i[bNƁAEnableEmmProcess, EnableLnbPowerւ̐ݒA
		/// SetChannel, SetChannelWithLockoȂȂ܂B
		/// bNNbL[gpUnlockĂяoȂƉ񕜂Ȃ߁AӂKvłB</remarks>
		Guid SetChannelWithLock(int tuningSpace, int channel, int serviceID);

		/// <summary>
		/// ݎM̃Xg[̃lbg[NID擾܂B
		/// </summary>
		int NetworkID
		{
			get;
		}

		/// <summary>
		/// ݎM̃Xg[̃lbg[N擾܂B
		/// </summary>
		string NetworkName
		{
			get;
		}

		/// <summary>
		/// ݎM̃Xg[̃gX|[gXg[ID擾܂B
		/// </summary>
		int TransportStreamID
		{
			get;
		}

		/// <summary>
		/// ݎM̃Xg[̊Jn擾܂B
		/// </summary>
		DateTime StreamTime
		{
			get;
		}

		/// <summary>
		/// ݎMĂEPG擾܂B
		/// </summary>
		IProgramInformation[] Programs
		{
			get;
		}

		/// <summary>
		/// XNȕԂ擾܂B
		/// </summary>
		DescramblingStates DescramblingStatus
		{
			get;
		}

		/// <summary>
		/// ̃`[i[MĂXg[擾邽߂̃L[𐶐܂B
		/// </summary>
		/// <param name="serviceID">Xg[̃T[rX肷T[rXID</param>
		/// <param name="programID">Xg[̃vO肷vOID</param>
		/// <param name="maxSize">L[ɕێXg[̍őoCg</param>
		/// <param name="locked">T[rXID̕ύXp[WȂꍇtrue</param>
		/// <returns>L[</returns>
		/// <remarks>T[rXIDƂ-1w肷ƁASẴXg[f[^L[ɒ~ς܂B
		/// 0w肷ƁAKȎM\ȃXg[f[^IĒ~ς܂B
		/// AAǂ̃Xg[f[^Iꂽ͕܂B
		/// vOIDƂ-1w肷ƁAvǑos܂B
		/// vOIDw肵ꍇ͈vvOoÃf[^~ς܂B
		/// Xg[f[^͑傫߁AőoCg傫Ȓlw肷Kv܂B
		/// L[ɒ~ςꂽf[^̃oCg𒴂ƁAL[̃f[^Iɔj܂B</remarks>
		IDataQueue CreateQueue(int serviceID, int programID, long maxSize, bool locked);

		#region Advanced
		/// <summary>
		/// CxgVNo^܂B
		/// </summary>
		/// <param name="packetSync">IPacketSyncEventCX^X</param>
		[EditorBrowsable(EditorBrowsableState.Advanced)]
		void RegisterEvent(IPacketSyncEvent packetSync);

		/// <summary>
		/// CxgVNo^܂B
		/// </summary>
		/// <param name="descramble">IDescrambleEventCX^X</param>
		[EditorBrowsable(EditorBrowsableState.Advanced)]
		void RegisterEvent(IDescrambleEvent descramble);

		/// <summary>
		/// CxgVN̓o^܂B
		/// </summary>
		/// <param name="packetSync">IPacketSyncEventCX^X</param>
		[EditorBrowsable(EditorBrowsableState.Advanced)]
		void UnregisterEvent(IPacketSyncEvent packetSync);

		/// <summary>
		/// CxgVN̓o^܂B
		/// </summary>
		/// <param name="descramble">IDescrambleEventCX^X</param>
		[EditorBrowsable(EditorBrowsableState.Advanced)]
		void UnregisterEvent(IDescrambleEvent descramble);
		#endregion
	}
}
