//////////////////////////////////////////////////////////////////////////
// BonSDK .NET binding interface library
// Copyright (c) http://2sen.dip.jp/dtv/
//
// This is part of BonSDK.
// BonSDK comes with ABSOLUTELY NO WARRANTY;
// for details see 'GNU GENERAL PUBLIC LICENSE 2.0'.

using System;
using System.Runtime.InteropServices;
using System.ComponentModel;

namespace Bon
{
	/// <summary>
	/// `[i`C^[tFCXłB
	/// </summary>
	[ComVisible(true)]
	[Guid("A9B972F2-4A0E-4e24-96D9-CFBEA2DED5C9")]
	[InterfaceType(ComInterfaceType.InterfaceIsDual)]
	[TypeConverter(typeof(ExpandableObjectConverter))]
	public interface ITunerDefinition
	{
		/// <summary>
		/// `[i[擾܂B
		/// </summary>
		/// <remarks>`[i[BonSDK̃`[i[NXłB</remarks>
		string TunerName
		{
			get;
		}

		/// <summary>
		/// foCX擾܂B
		/// </summary>
		/// <remarks>foCX̓`[i[NX瓾ꂽ[U[ǉ\ȕłB</remarks>
		string DeviceName
		{
			get;
		}

		/// <summary>
		/// ̃`[i[M\ȃ`[jOXy[Xƃ`l̏擾܂B
		/// </summary>
		ITuningSpaceInformation[] TuningSpaces
		{
			get;
		}

		/// <summary>
		/// CASJ[h[_̃ftHgNX擾܂B
		/// </summary>
		string DefaultCasCardReader
		{
			get;
		}

		/// <summary>
		/// `[i[CX^X𐶐܂B
		/// </summary>
		/// <param name="casCardReader">CASJ[h[_̃NX</param>
		/// <returns>`[i[CX^X</returns>
		/// <remarks>gp̃`[i[݂ȂꍇAOX[܂B</remarks>
		ITuner CreateTuner(string casCardReader);
	}
}
