//////////////////////////////////////////////////////////////////////////
// BonSDK .NET binding interface library
// Copyright (c) http://2sen.dip.jp/dtv/
//
// This is part of BonSDK.
// BonSDK comes with ABSOLUTELY NO WARRANTY;
// for details see 'GNU GENERAL PUBLIC LICENSE 2.0'.

using System;
using System.Collections;
using System.Collections.Generic;
using System.ComponentModel;
using System.Runtime.InteropServices;

namespace Bon.Remoting
{
	/// <summary>
	/// `l𒊏ۉNXłB
	/// </summary>
	/// <remarks>̃NX̓VA\œǂݎpłB</remarks>
	[Serializable]
	[TypeConverter(typeof(ExpandableObjectConverter))]
	public sealed class RemoteChannelInformation : IRemoteChannelInformation
	{
		private readonly string name_;
		private readonly IRemoteServiceInformation[] services_;

		/// <summary>
		/// RXgN^łB
		/// </summary>
		/// <param name="channel">`l</param>
		public RemoteChannelInformation(IChannelInformation channel)
		{
			name_ = channel.Name;
			List<IRemoteServiceInformation> temp = new List<IRemoteServiceInformation>();
			foreach (IServiceInformation service in channel)
			{
				temp.Add(new RemoteServiceInformation(service));
			}
			services_ = temp.ToArray();
		}

		/// <summary>
		/// `l擾܂B
		/// </summary>
		[Category("Channel")]
		public string Name
		{
			get
			{
				return name_;
			}
		}

		/// <summary>
		/// T[rXQ擾܂B
		/// </summary>
		[Category("Service")]
		public IRemoteServiceInformation[] Services
		{
			get
			{
				return services_;
			}
		}
	}
}
