//////////////////////////////////////////////////////////////////////////
// BonSDK .NET binding interop library
// Copyright (c) http://2sen.dip.jp/dtv/
//
// This is part of BonSDK.
// BonSDK comes with ABSOLUTELY NO WARRANTY;
// for details see 'GNU GENERAL PUBLIC LICENSE 2.0'.


#include "stdafx.h"

#include "ManagedLock.h"

namespace Bon
{
	namespace Internal
	{
		ManagedLock::ManagedLock(System::Object^ target)
			: target_(target)
		{
			System::Threading::Monitor::Enter(target_);
		}

		ManagedLock::~ManagedLock()
		{
			System::Threading::Monitor::Exit(target_);
		}
	}
}
