//////////////////////////////////////////////////////////////////////////
// BonSDK .NET binding interop library
// Copyright (c) http://2sen.dip.jp/dtv/
//
// This is part of BonSDK.
// BonSDK comes with ABSOLUTELY NO WARRANTY;
// for details see 'GNU GENERAL PUBLIC LICENSE 2.0'.


#pragma once

namespace Bon
{
	ref class ServiceInformation sealed
		: public IServiceInformation
	{
	private:
		initonly System::String^ name_;
		initonly int serviceID_;

		virtual IServiceInformation^ InterfaceClone() sealed = IServiceInformation::Clone;
		virtual System::Object^ ObjectClone() sealed = System::ICloneable::Clone;

		ServiceInformation(ServiceInformation^ rhs);

	internal:
		ServiceInformation(System::String^ name, int serviceID);

	public:
		virtual int GetHashCode() override;

		property System::String^ Name
		{
			virtual System::String^ get();
		}

		property int ServiceID
		{
			virtual int get();
		}

		virtual ServiceInformation^ Clone();
	};
}
