//////////////////////////////////////////////////////////////////////////
// BonSDK .NET binding interop library
// Copyright (c) http://2sen.dip.jp/dtv/
//
// This is part of BonSDK.
// BonSDK comes with ABSOLUTELY NO WARRANTY;
// for details see 'GNU GENERAL PUBLIC LICENSE 2.0'.


#include "stdafx.h"

#include "TsData.h"
#include "DataQueueManager.h"

namespace Bon
{
	TsData::TsData(Internal::DataQueueManager^ dataQueueManager, int bufferSize)
		: dataQueueManager_(dataQueueManager), buffer_(gcnew array<System::Byte>(bufferSize)), dataSize_(0)
	{
		// 傫ȃ}l[WIuWFNǵALOH / GC Gen2 ɔzuAړȂB
		// ̂߁AGCHandleŌŒ艻ȂĂptH[}XێłB
	}

	TsData::~TsData()
	{
		int result = System::Threading::Interlocked::Decrement(lockCount_);
		if (result == 0)
		{
			dataSize_ = 0;
			dataQueueManager_->RecycleBuffer(this);
		}
		else if (result < 0)
		{
			System::Threading::Interlocked::Increment(lockCount_);
		}
	}

	void TsData::AddRef()
	{
		System::Threading::Interlocked::Increment(lockCount_);
	}

	bool TsData::Append(const BYTE *pData, int size)
	{
		// ̃NX̓}l[WNXȂ̂ŁAmemcpygpƃA}l[WJڂB
		// Marshal::CopyłA}l[WJڂ邪AInternalCallɃ}bvĂ̂memcpyȂB

		int newSize = dataSize_ + size;
		if (newSize > buffer_->Length)
		{
			return false;
		}
		System::Runtime::InteropServices::Marshal::Copy(System::IntPtr(const_cast<BYTE *>(pData)), buffer_, dataSize_, size);
		dataSize_ = newSize;
		return true;
	}

	int TsData::BufferSize::get()
	{
		return buffer_->Length;
	}

	int TsData::Size::get()
	{
		return dataSize_;
	}

	array<System::Byte>^ TsData::Data::get()
	{
		return buffer_;
	}
}
