//////////////////////////////////////////////////////////////////////////
// BonSDK .NET binding interop library
// Copyright (c) http://2sen.dip.jp/dtv/
//
// This is part of BonSDK.
// BonSDK comes with ABSOLUTELY NO WARRANTY;
// for details see 'GNU GENERAL PUBLIC LICENSE 2.0'.


#pragma once

namespace Bon
{
	namespace Internal
	{
		ref class DataQueueManager;
	}

	ref class TsData sealed
		: public ITsData
	{
	private:
		initonly Internal::DataQueueManager^ dataQueueManager_;
		initonly array<System::Byte>^ buffer_;
		int dataSize_;
		int lockCount_;

	internal:
		TsData(Internal::DataQueueManager^ dataQueueManager, int bufferSize);
		void AddRef();
		bool Append(const BYTE *pData, int size);

		property int BufferSize
		{
			virtual int get();
		}

	public:
		~TsData();

		property int Size
		{
			virtual int get();
		}

		property array<System::Byte>^ Data
		{
			virtual array<System::Byte>^ get();
		}
	};
}
