//////////////////////////////////////////////////////////////////////////
// BonSDK .NET binding interop library
// Copyright (c) http://2sen.dip.jp/dtv/
//
// This is part of BonSDK.
// BonSDK comes with ABSOLUTELY NO WARRANTY;
// for details see 'GNU GENERAL PUBLIC LICENSE 2.0'.


#include "stdafx.h"

#include "TunerDefinition.h"
#include "Tuner.h"

namespace Bon
{
	TunerDefinition::TunerDefinition(System::String^ tunerName, System::String^ deviceName,
		array<ITuningSpaceInformation^>^ tuningSpaces)
		: tunerName_(tunerName), deviceName_(deviceName), tuningSpaces_(tuningSpaces)
	{
	}

	System::String^ TunerDefinition::TunerName::get()
	{
		return tunerName_;
	}

	System::String^ TunerDefinition::DeviceName::get()
	{
		return deviceName_;
	}

	array<ITuningSpaceInformation^>^ TunerDefinition::TuningSpaces::get()
	{
		return tuningSpaces_;
	}

	System::String^ TunerDefinition::DefaultCasCardReader::get()
	{
		return "CCasCardReader";
	}

	ITuner^ TunerDefinition::CreateTuner(System::String^ casCardReader)
	{
		return gcnew Tuner(this, casCardReader);
	}
}
