//////////////////////////////////////////////////////////////////////////
// BonSDK Stream service remote controller
// Copyright (c) http://2sen.dip.jp/dtv/
//
// This is part of BonSDK.
// BonSDK comes with ABSOLUTELY NO WARRANTY;
// for details see 'GNU GENERAL PUBLIC LICENSE 2.0'.

using System;

namespace Bon
{
	/// <summary>
	/// ͂ꂽvOC^[tFCXłB
	/// </summary>
	internal interface IInputProgramInformation
	{
		/// <summary>
		/// Iꂽ`[jOXy[X擾܂B
		/// </summary>
		int TuningSpace
		{
			get;
		}

		/// <summary>
		/// Iꂽ`l擾܂B
		/// </summary>
		int Channel
		{
			get;
		}

		/// <summary>
		/// ͂ꂽT[rXID擾܂B
		/// </summary>
		int ServiceID
		{
			get;
		}

		/// <summary>
		/// ͂ꂽvOID擾܂B
		/// </summary>
		int ProgramID
		{
			get;
		}

		/// <summary>
		/// IꂽR[_[^O擾܂B
		/// </summary>
		StreamServiceTag SelectedRecorder
		{
			get;
		}

		/// <summary>
		/// IꂽXg[WID擾܂B
		/// </summary>
		string StorageID
		{
			get;
		}

		/// <summary>
		/// IꂽXg[URL擾܂B
		/// </summary>
		IUrl StreamUrl
		{
			get;
		}

		/// <summary>
		/// Jn擾܂B
		/// </summary>
		DateTime StartTime
		{
			get;
		}

		/// <summary>
		/// I擾܂B
		/// </summary>
		DateTime EndTime
		{
			get;
		}

		/// <summary>
		/// ͂ꂽt@C擾܂B
		/// </summary>
		string FileName
		{
			get;
		}
	}
}
