//////////////////////////////////////////////////////////////////////////
// BonSDK Stream service remote controller
// Copyright (c) http://2sen.dip.jp/dtv/
//
// This is part of BonSDK.
// BonSDK comes with ABSOLUTELY NO WARRANTY;
// for details see 'GNU GENERAL PUBLIC LICENSE 2.0'.

using System;
using System.Net;
using Bon.Remoting;

namespace Bon
{
	/// <summary>
	/// w肳ꂽ[g`[i[ɑ΂ăT[rXIDݒ肷NXłB
	/// </summary>
	internal sealed class ProgramSetter
	{
		private readonly IRemoteTuner tuner_;
		private readonly IStreamEndPoint endPoint_;
		private readonly int serviceID_;

		/// <summary>
		/// RXgN^łB
		/// </summary>
		/// <param name="tuner">[g`[i[Q</param>
		/// <param name="endPoint">T[rXIDݒ肷Ώۂ̃Xg[NCAg</param>
		/// <param name="serviceID">ݒ肷T[rXID</param>
		public ProgramSetter(IRemoteTuner tuner, IStreamEndPoint endPoint, int serviceID)
		{
			tuner_ = tuner;
			endPoint_ = endPoint;
			serviceID_ = serviceID;
		}

		/// <summary>
		/// T[rXID̐ݒs܂B
		/// </summary>
		public void SetProgram()
		{
			tuner_.SetServiceID(endPoint_, serviceID_);
		}
	}
}
