//////////////////////////////////////////////////////////////////////////
// BonSDK EARTHSOFT PT2 tuner library
// Copyright (c) http://2sen.dip.jp/dtv/
//
// This is part of BonSDK.
// BonSDK comes with ABSOLUTELY NO WARRANTY;
// for details see 'GNU GENERAL PUBLIC LICENSE 2.0'.

// Pt2SatTuner.h: PT2 BS/110CS`[iNX
//
/////////////////////////////////////////////////////////////////////////////

#pragma once


#include "Pt2BaseTuner.h"



/////////////////////////////////////////////////////////////////////////////
// PT2 BS/110CS`[iNX
/////////////////////////////////////////////////////////////////////////////

class CPt2SatTuner :	public CPt2BaseTuner
{
public:
// CBonObject
	DECLARE_IBONOBJECT(CPt2SatTuner)

// CPt2BaseTuner
	virtual const CBonString EnumTuningSpace(const DWORD dwSpace) const;
	virtual const CBonString EnumChannelName(const DWORD dwSpace, const DWORD dwChannel) const;
	virtual const bool SetChannel(const DWORD dwSpace, const DWORD dwChannel);

// IConfigTarget
	virtual const bool SetProperty(const IConfigProperty *pProperty);

// CPt2SatTuner
	CPt2SatTuner(IBonObject *pOwner);
	virtual ~CPt2SatTuner(void);

protected:
};
