//////////////////////////////////////////////////////////////////////////
// BonSDK TCP Server library
// Copyright (c) http://2sen.dip.jp/dtv/
//
// This is part of BonSDK.
// BonSDK comes with ABSOLUTELY NO WARRANTY;
// for details see 'GNU GENERAL PUBLIC LICENSE 2.0'.

// DllMain.cpp: DLLGg[|Cg̒`
//
/////////////////////////////////////////////////////////////////////////////

// TsTcpServer.h: TCP TST[oNX
//
/////////////////////////////////////////////////////////////////////////////

#pragma once


#include <vector>
#include <queue>


/////////////////////////////////////////////////////////////////////////////
// TCP TST[oNX
/////////////////////////////////////////////////////////////////////////////

class CTsTcpServer	:	public CBonObject
{
public:
// CBonObject
	DECLARE_IBONOBJECT(CTsTcpServer)

// ITsTcpServer
	virtual const bool OpenServer(const WORD wServerPort /* ITsSrcManager */);
	virtual void CloseServer(void);

// CTsTcpServer
	CTsTcpServer(IBonObject *pOwner);
	virtual ~CTsTcpServer(void);
	
protected:
	virtual void AcceptThread(CSmartThread<CTsTcpServer> *pThread, bool &bKillSignal, const ULONG_PTR param);

	CSmartThread<CTsTcpServer> m_AcceptThread;

	ISmartSocket *m_pServerSocket;
};
